"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _insert = _interopRequireDefault(require("./insert.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var useSimpleUndo = function useSimpleUndo(initialState) {
  var _React$useState = _react.default.useState([initialState]),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      state = _React$useState2[0],
      setState = _React$useState2[1];

  var _React$useState3 = _react.default.useState(0),
      _React$useState4 = _slicedToArray(_React$useState3, 2),
      cursor = _React$useState4[0],
      setCursor = _React$useState4[1];

  var undo = function undo() {
    return setCursor(cursor - 1);
  };

  var redo = function redo() {
    return setCursor(cursor + 1);
  };

  var setValue = function setValue(value) {
    var nextCursor = cursor + 1;
    var nextState = (0, _insert.default)(state, nextCursor, value);
    setState(nextState);
    setCursor(nextCursor);
  };

  return [state, cursor, setValue, {
    undo: undo,
    redo: redo
  }];
};

var _default = useSimpleUndo;
exports.default = _default;